/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8970_SUPSTPO.sql

Descrio:
Ajusta a conta a pagar prevista quando uma ou mais itens de uma AF
so baixados manualmente ou a AF  cancelada/encerrada.

Criao:
10/11/2006 Marcelo Alexsandro Souza Silva

*/

CREATE OR REPLACE PROCEDURE AJUSTE_CONTPREVISTA
(
   P_CDFILDEST   IN AUTOFORNE.CDFILDEST%TYPE,
   P_CDFILLANC   IN AUTOFORNE.CDFILLANC%TYPE,
   P_NRAUTOFORN  IN AUTOFORNE.NRAUTOFORN%TYPE
)
IS
   V_3      CHAR(1)   := '3';
   V_A      CHAR(1)   := 'A';
   V_D      CHAR(1)   := 'D';
   V_R      CHAR(1)   := 'R';
   V_TOTITM_VRDESC       NUMBER; /* DESCONTOS DO PRODUTO */
   V_TOTITM_VRPROD       NUMBER; /* VALOR BRUTO DOS PRODUTOS */
   V_TOTITM_VRPROD_REST  NUMBER; /* VALOR BRUTO RESTANTE DOS PRODUTOS */
   V_TOTITM_TOT          NUMBER; /* VALOR BRUTO DOS PRODUTOS MENOS DESCONTOS */
   V_TOTIMP_TOT_REST     NUMBER; /* TOTAL DE IMPOSTOS PROPROCIONAL AO RESTANTE A SER ENTREGUE */
   V_TOTIMP_TOT          NUMBER; /* TOTAL DE IMPOSTOS */
   V_ENCACRES_TOTACRES   NUMBER; /* ENCARGOS A ACRESCER */
   V_ENCDESC_TOTDESC     NUMBER; /* ENCARGOS A DESCONTAR */
   V_IMPRETER_TOTIMPRET  NUMBER; /* IMPOSTOS A RETER NA FONTE */
   V_VRTOTCTPAGAR        NUMBER; /* TOTAL DAS CONTAS A PAGAR */
   V_VRTOTAL_REST        NUMBER; /* NOVO VALOR DAS CONTAS A PAGAR (RESTANTE A SER ENTREGUE) */
   V_VRATUAPAGAUX        NUMBER;
   V_IDSTATUSAUX         VARCHAR2(1);
   V_IDGERCONTPGT        VARCHAR2(1);
   V_IDCONSORCFIN        VARCHAR2(1);
   V_IDTPORCAFINA        VARCHAR2(1);
   V_CDFILIAL            VARCHAR2(4);
BEGIN
   FOR C_FORNECEDOR IN
      (SELECT
          CDFORNECED,
          IDBAIXAAF
       FROM
          AUTOFORNE
       WHERE
          CDFILDEST  = P_CDFILDEST   AND
          CDFILLANC  = P_CDFILLANC   AND
          NRAUTOFORN = P_NRAUTOFORN)
   LOOP
      BEGIN
         SELECT
            IDGERCONTPGT INTO V_IDGERCONTPGT
         FROM
            FORNECEDOR
         WHERE
            CDFORNECED = C_FORNECEDOR.CDFORNECED;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDGERCONTPGT := 'S';
      END;

      BEGIN
         SELECT
            IDCONSORCFIN, IDTPORCAFINA INTO V_IDCONSORCFIN, V_IDTPORCAFINA
         FROM
            PARAMGERAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDCONSORCFIN := 'N';
            V_IDTPORCAFINA := 'E';
      END;

      FOR C_NOTAPREVISTA IN /* PEGA A NOTA DA CONTA A PAGAR PREVISTA */
         (SELECT DISTINCT
             NRLANCTONF,
             DTPROGENTAF
          FROM
             ITEMAUTF
          WHERE
             CDFILLANC  = P_CDFILLANC AND
             CDFILDEST  = P_CDFILDEST AND
             NRAUTOFORN = P_NRAUTOFORN)
      LOOP
      /*############################# TOTAL DOS ITEMS ##########################################*/
         IF C_FORNECEDOR.IDBAIXAAF IN ('3', '4', '5') THEN
            V_TOTITM_VRPROD_REST := 0;
            SELECT
               SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * (NVL(ITEMAUTF.VRPERDESAF,0) / 100)),
               SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
               SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) -
                  ((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) *
                    NVL(ITEMAUTF.VRPERDESAF,0) / 100))
               INTO
                  V_TOTITM_VRDESC,
                  V_TOTITM_VRPROD,
                  V_TOTITM_TOT
            FROM
               ITEMAUTF
            WHERE
               ITEMAUTF.CDFILDEST   = P_CDFILDEST    AND
               ITEMAUTF.CDFILLANC   = P_CDFILLANC    AND
               ITEMAUTF.NRAUTOFORN  = P_NRAUTOFORN   AND
               ITEMAUTF.DTPROGENTAF = C_NOTAPREVISTA.DTPROGENTAF;

         /*############################### TOTAL DOS IMPOSTOS #####################################*/
            V_TOTIMP_TOT_REST := 0;
            SELECT
               SUM (IMPITMAF.VRADIMPAF )
               INTO
                  V_TOTIMP_TOT
            FROM
               IMPITMAF,
               ITEMAUTF
            WHERE
               ITEMAUTF.CDFILDEST   = P_CDFILDEST       AND
               ITEMAUTF.CDFILLANC   = P_CDFILLANC       AND
               ITEMAUTF.NRAUTOFORN  = P_NRAUTOFORN      AND
               ITEMAUTF.DTPROGENTAF = C_NOTAPREVISTA.DTPROGENTAF AND
               IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST         AND
               IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC         AND
               IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN        AND
               IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO         AND
               IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA           AND
               IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF;
         ELSE
            SELECT
               SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * (NVL(ITEMAUTF.VRPERDESAF,0) / 100)),
               SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
               SUM((ITEMAUTF.QTPROGENTAF - DECODE(ITEMAUTF.IDBAIXITMAF, V_3, ITEMAUTF.QTPROGENTAF, NVL(ITEMAUTF.QTEFETENTRAF, 0))) * ITEMAUTF.VRPREUNIAF),
               SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) -
                  ((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) *
                    NVL(ITEMAUTF.VRPERDESAF,0) / 100))
               INTO
                  V_TOTITM_VRDESC,
                  V_TOTITM_VRPROD,
                  V_TOTITM_VRPROD_REST,
                  V_TOTITM_TOT
            FROM
               ITEMAUTF
            WHERE
               ITEMAUTF.CDFILDEST   = P_CDFILDEST    AND
               ITEMAUTF.CDFILLANC   = P_CDFILLANC    AND
               ITEMAUTF.NRAUTOFORN  = P_NRAUTOFORN   AND
               ITEMAUTF.DTPROGENTAF = C_NOTAPREVISTA.DTPROGENTAF;

         /*############################### TOTAL DOS IMPOSTOS #####################################*/
            SELECT
               SUM (IMPITMAF.VRADIMPAF * (ITEMAUTF.QTPROGENTAF - DECODE(ITEMAUTF.IDBAIXITMAF, V_3, ITEMAUTF.QTPROGENTAF, NVL(ITEMAUTF.QTEFETENTRAF, 0)))/ITEMAUTF.QTPROGENTAF),
               SUM (IMPITMAF.VRADIMPAF )
               INTO
                  V_TOTIMP_TOT_REST,
                  V_TOTIMP_TOT
            FROM
               IMPITMAF,
               ITEMAUTF
            WHERE
               ITEMAUTF.CDFILDEST   = P_CDFILDEST       AND
               ITEMAUTF.CDFILLANC   = P_CDFILLANC       AND
               ITEMAUTF.NRAUTOFORN  = P_NRAUTOFORN      AND
               ITEMAUTF.DTPROGENTAF = C_NOTAPREVISTA.DTPROGENTAF AND
               IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST         AND
               IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC         AND
               IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN        AND
               IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO         AND
               IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA           AND
               IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF       AND
               NVL(ITEMAUTF.QTPROGENTAF, 0) > 0;
         END IF;

      /*########################## ENCARGOS A ACRESCER #########################################*/
         SELECT
            SUM(ENCARGOAF.VRENCARGOAF) INTO V_ENCACRES_TOTACRES
         FROM
            ENCARGOAF, ENCARGO
         WHERE
            ENCARGOAF.CDFILDEST   = P_CDFILDEST  AND
            ENCARGOAF.CDFILLANC   = P_CDFILLANC  AND
            ENCARGOAF.NRAUTOFORN  = P_NRAUTOFORN AND
            ENCARGOAF.DTENTRENCAF = C_NOTAPREVISTA.DTPROGENTAF AND
            ENCARGOAF.CDENCARGO   = ENCARGO.CDENCARGO AND
            ENCARGO.IDENCARGO     = V_A;

      /*########################## ENCARGOS A DESCONTAR ########################################*/
         SELECT
            SUM(ENCARGOAF.VRENCARGOAF) INTO V_ENCDESC_TOTDESC
         FROM
            ENCARGOAF, ENCARGO
         WHERE
            ENCARGOAF.CDFILDEST   = P_CDFILDEST  AND
            ENCARGOAF.CDFILLANC   = P_CDFILLANC  AND
            ENCARGOAF.NRAUTOFORN  = P_NRAUTOFORN AND
            ENCARGOAF.DTENTRENCAF = C_NOTAPREVISTA.DTPROGENTAF AND
            ENCARGOAF.CDENCARGO   = ENCARGO.CDENCARGO AND
            ENCARGO.IDENCARGO     = V_D;

      /*########################## IMPOSTOS A RETER ############################################*/
         SELECT
            SUM(IMPITMAF.VRIMPITMAF) INTO V_IMPRETER_TOTIMPRET
         FROM
            IMPOSTO, IMPITMAF
         WHERE
            IMPITMAF.CDFILDEST   = P_CDFILDEST AND
            IMPITMAF.CDFILLANC   = P_CDFILLANC AND
            IMPITMAF.NRAUTOFORN  = P_NRAUTOFORN AND
            IMPITMAF.DTPROGENTAF = C_NOTAPREVISTA.DTPROGENTAF AND
            IMPOSTO.CDIMPOSTO    = IMPITMAF.CDIMPOSTO  AND
            IMPOSTO.IDTRATIMPO   = V_R;

      /*########################### CALCULO DOS VALORES ########################################*/
         V_VRTOTCTPAGAR := ROUND(V_TOTITM_TOT
                                 + NVL(V_TOTIMP_TOT,0)
                                 + NVL(V_ENCACRES_TOTACRES,0)
                                 - NVL(V_ENCDESC_TOTDESC,0)
                                 - NVL(V_IMPRETER_TOTIMPRET, 0), 5);

         V_VRTOTAL_REST := ROUND(V_TOTITM_VRPROD_REST + NVL(V_TOTIMP_TOT_REST,0), 5);
         IF V_TOTITM_VRPROD = V_TOTITM_VRPROD_REST THEN /* SE OS ITEMS ESTIVEREM EM ABERTO... */
            V_VRTOTAL_REST := ROUND(V_VRTOTAL_REST
                                    - NVL(V_TOTITM_VRDESC,0)
                                    + NVL(V_ENCACRES_TOTACRES,0)
                                    - NVL(V_ENCDESC_TOTDESC,0)
                                    - NVL(V_IMPRETER_TOTIMPRET, 0), 5);
         END IF;
         IF V_VRTOTAL_REST < 0 THEN
            V_VRTOTAL_REST := 0;
         END IF;

      /*########################### MOVIMENTO DE FLUXO #########################################*/
         FOR C_CONTAPAGAR IN
            (SELECT
                CDEMPRESA,
                DTMOVFLUXO,
                IDMOVFLUXO,
                CDCLASSFINA,
                VRORIGPAG,
                VRATUAPAG
             FROM
                CONTAPAGAR
             WHERE
                CDFILIAL   = P_CDFILLANC               AND
                NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF)
         LOOP
            V_VRATUAPAGAUX := ROUND(V_VRTOTAL_REST * C_CONTAPAGAR.VRORIGPAG / V_VRTOTCTPAGAR,2);
            V_VRATUAPAGAUX := V_VRATUAPAGAUX - C_CONTAPAGAR.VRATUAPAG;
            ATUALIZA_FLUXO_DE_CAIXA(C_CONTAPAGAR.CDEMPRESA,
                                    P_CDFILDEST,
                                    C_CONTAPAGAR.DTMOVFLUXO,
                                    C_CONTAPAGAR.IDMOVFLUXO,
                                    C_CONTAPAGAR.CDCLASSFINA,
                                    0,
                                    V_VRATUAPAGAUX);
            UPDATE MOVFLUXAF
            SET VRPREVAF = VRPREVAF + V_VRATUAPAGAUX
            WHERE
               CDFILDEST    = P_CDFILDEST  AND
               CDFILLANC    = P_CDFILLANC  AND
               NRAUTOFORN   = P_NRAUTOFORN AND
               CDCLASSFINAF = C_CONTAPAGAR.CDCLASSFINA AND
               DTENTMOVAF   = C_NOTAPREVISTA.DTPROGENTAF AND
               DTPREVVENC   = C_CONTAPAGAR.DTMOVFLUXO;

      /*######################## ORCAMENTO FINANCEIRO ##########################################*/
            IF V_IDCONSORCFIN = 'S' THEN
               V_CDFILIAL := NULL;
               IF V_IDTPORCAFINA = 'F' THEN
                  V_CDFILIAL := P_CDFILDEST;
               END IF;
               FOR C_ORCAFINA IN
                  (SELECT
                      CDEMPRESA,
                      CDFILIAL,
                      CDCLASSFINA,
                      DTORCAFINA
                   FROM
                      ORCAFINA
                   WHERE
                      (CDEMPRESA   = C_CONTAPAGAR.CDEMPRESA) AND
                      (CDFILIAL    = NVL(V_CDFILIAL, CDFILIAL)) AND
                      (CDCLASSFINA = C_CONTAPAGAR.CDCLASSFINA) AND
                      (DTORCAFINA BETWEEN C_CONTAPAGAR.DTMOVFLUXO - TO_CHAR(C_CONTAPAGAR.DTMOVFLUXO, 'DD') + 1 AND
                                          LAST_DAY(C_CONTAPAGAR.DTMOVFLUXO)) )
               LOOP
                  UPDATE ORCAFINA
                  SET
                     VRREALORCA = VRREALORCA + V_VRATUAPAGAUX
                  WHERE
                     CDCLASSFINA = C_ORCAFINA.CDCLASSFINA AND
                     CDEMPRESA   = C_ORCAFINA.CDEMPRESA AND
                     DTORCAFINA  = C_ORCAFINA.DTORCAFINA AND
                     CDFILIAL    = C_ORCAFINA.CDFILIAL;
               END LOOP;
            END IF;
         END LOOP;
      /*############################ AJUSTE NA CONTA A PAGAR ###################################*/
         UPDATE CONTAPAGAR
         SET VRATUAPAG = ROUND(V_VRTOTAL_REST * VRORIGPAG / V_VRTOTCTPAGAR, 2)
         WHERE
            CDFILIAL   = P_CDFILLANC AND
            NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;

      /*############################ CANCELA A NOTA FISCAL (SE NECESSARIO) #####################*/
         /* SE CONTAPAGAR.VRATUAPAG <= 0 ENTAO CANCELA A NF*/
         SELECT
            SUM(CONTAPAGAR.VRATUAPAG)
         INTO
            V_VRATUAPAGAUX
         FROM
            CONTAPAGAR
         WHERE
            CONTAPAGAR.CDFILIAL   = P_CDFILLANC     AND
            CONTAPAGAR.NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;

         V_IDSTATUSAUX := 'V';
         IF V_VRATUAPAGAUX <= 0 THEN
            V_IDSTATUSAUX := 'C';
         END IF;

         UPDATE NOTAFISCAL
         SET IDSTATUS = V_IDSTATUSAUX
         WHERE
            CDFILIAL   = P_CDFILLANC AND
            NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;
      END LOOP;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('AJUSTE_CONTPREVISTA','4.11.003'); END;
/

